#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum MetricColumnThresholdType {
    #[serde(rename = "RAW")]
    Raw,
    #[serde(rename = "BAR")]
    Bar,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl MetricColumnThresholdType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            MetricColumnThresholdType::Raw => "RAW",
            MetricColumnThresholdType::Bar => "BAR",
            MetricColumnThresholdType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for MetricColumnThresholdType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for MetricColumnThresholdType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for MetricColumnThresholdType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<MetricColumnThresholdType, conjure_object::plain::ParseEnumError> {
        match v {
            "RAW" => Ok(MetricColumnThresholdType::Raw),
            "BAR" => Ok(MetricColumnThresholdType::Bar),
            v => v.parse().map(|v| MetricColumnThresholdType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for MetricColumnThresholdType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<MetricColumnThresholdType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the MetricColumnThresholdType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
